package ee.primes;

import jakarta.annotation.PostConstruct;
import jakarta.inject.Named;
import jakarta.enterprise.context.RequestScoped;

import java.util.ArrayList;
import java.util.List;

@Named
@RequestScoped
public class PrimeCalculator {

    private int n;
    private int cnt = 0;

    private List<Integer> primes;

    @PostConstruct
    public void init() {
        // In @PostConstruct (will be invoked immediately after construction and dependency/property injection).
        System.out.println("@PostConstruct init() n=" + n + ", cnt=" + (cnt++));
    }

    private void calculatePrimes()
    {
        System.out.println("calculatePrimes() n=" + n + ", cnt=" + (cnt++));
        primes = new ArrayList<>();
        boolean compound[] = new boolean[n + 1];
        for (int i = 2; i <= n; i++)
            if (!compound[i])
            {
                primes.add(i);
                for (int j = 2 * i; j <= n; j += i) compound[j] = true;
            }
    }

    public List<Integer> getPrimes()
    {
        System.out.println("getPrimes() n=" + n + ", cnt=" + (cnt++) + "primes==null: " + (primes == null));
        if (primes == null) calculatePrimes();
        return primes;
    }

    public int getN() {
        return n;
    }

    public void setN(int n) {
        System.out.println("setN() n=" + n + ", cnt=" + (cnt++));
        this.n = n;
        primes = null;
    }
}
